#include <sourcemod>
#include <geoip>
#include <adminmenu>
#include <multicolors>
#undef REQUIRE_EXTENSIONS
#include <geoipcity>
#define REQUIRE_EXTENSIONS
#undef REQUIRE_PLUGIN
#include <vip_core>
#define REQUIRE_PLUGIN

#define PLUGIN_VERSION		"1.4.1"

// ConVars
ConVar sPluginEnabled;
ConVar sCanCheck;
ConVar sVIP;
ConVar sSteamID;
ConVar sFlag;
ConVar sAdmin;
ConVar sMember;
ConVar sShow;
ConVar sJoinMessage;
ConVar sDisconnectMessage;
ConVar sCountry;
ConVar sAllowBots;

// Global
int totalmembers = 0;
Handle db = INVALID_HANDLE;
bool console = false;
bool sVIPPluginExists;

public Plugin myinfo = 
{
    name        = "[CSS/CSGO/ANY?] Who is",
    author      = "SLAYER, Vertigo",
    description = "Shows Steamid , Oldest Name, IP Address, Country, VIP Status, Admin Status, Member Number by Using SQLite Database",
    version     = PLUGIN_VERSION,
    url         = "https://forums.alliedmods.net/member.php?u=293943"
};
public void OnPluginStart()
{
	sPluginEnabled = CreateConVar("sm_whois_enabled", "1", "Enable/disable Whois plugin. (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sCanCheck = CreateConVar("sm_whois_checkip", "1", "Who Can See Player IP Address (0 = ALL, 1 = Admins Only)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sFlag = CreateConVar("sm_whois_adminflag", "z", "Admin flag Which can see player IP address");
	sVIP = CreateConVar("sm_whois_vip","1", "Show Player VIP Status (1= Yes, 0 = NO)(Required VIP-Core by R1ko)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sSteamID = CreateConVar("sm_whois_steamid","1", "Show Player SteamID (1= Yes, 0 = NO)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sAdmin = CreateConVar("sm_whois_admin","1", "Show Player Admin Status (1= Yes, 0 = NO)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sMember = CreateConVar("sm_whois_member","1", "Show Player Member Number (1= Yes, 0 = NO)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sCountry = CreateConVar("sm_whois_country","1", "Show Player Country Name (1= Yes, 0 = NO)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sShow =  CreateConVar("sm_whois_showserver","1", "Show Player Information in Server Console (1= Yes, 0 = NO)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sAllowBots = CreateConVar("sm_whois_allow_bots","1", "Show Bots name in 'sm_whois' menu (1= Yes, 0 = NO)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sJoinMessage = CreateConVar("sm_whois_join_msg","1", "Show Message on Player Join (1= Yes, 0 = NO)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sDisconnectMessage = CreateConVar("sm_whois_dis_msg","1", "Show Message on Player Disconnect (1= Yes, 0 = NO)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	RegConsoleCmd("sm_whois", cmd_whoisplayers);
	LoadTranslations("common.phrases");
	LoadTranslations("SLAYER_Whois.phrases");
	AutoExecConfig(true, "SLAYER_Whois");
	InitializeDB();
}
stock bool CheckPlayerFlags(int client)
{
    char sCvarFlags[26];
    sFlag.GetString(sCvarFlags, sizeof(sCvarFlags));
    int CvarFlags = ReadFlagString(sCvarFlags);
    int ClientFlags = GetUserFlagBits(client);
    if(ClientFlags & CvarFlags == CvarFlags){return true;}
    return false;
}
public void InitializeDB()
{
	char error[255];
	db = SQL_ConnectEx(SQL_GetDriver("sqlite"), "", "", "", "slayer_whois", error, sizeof(error), true, 0);
	if(db == INVALID_HANDLE)
	{
		SetFailState(error);
	}
	SQL_LockDatabase(db);
	SQL_FastQuery(db, "CREATE TABLE IF NOT EXISTS slayer_whois (steam_id TEXT, oldname TEXT, member INTEGER, clientname TEXT);");
	SQL_UnlockDatabase(db);
}
public void OnClientAuthorized(int client)
{
	if(sPluginEnabled.BoolValue)
	{
		char queryBuffer1[255];
		Format(queryBuffer1, sizeof(queryBuffer1), "SELECT *FROM slayer_whois");
		SQL_TQuery(db, findtotalmemebers, queryBuffer1, GetClientSerial(client));
		char queryBuffer[255], clientid[40];
		GetClientAuthId(client, AuthId_Engine, clientid, sizeof(clientid));
		Format(queryBuffer, sizeof(queryBuffer), "SELECT *FROM slayer_whois WHERE steam_id='%s'", clientid);
		SQL_TQuery(db, joinCallback, queryBuffer, GetClientSerial(client));
		
	}
}
public void findtotalmemebers(Handle owner, Handle hndl, const char[] error, any clientSerial)
{
        if(hndl == INVALID_HANDLE)
        {
                ThrowError("SQL error: %s", error);
                return;
        }
        if(SQL_GetRowCount(hndl) > 0)
        {
                totalmembers = SQL_GetRowCount(hndl);
        }
        else
        {
               totalmembers = 0; 
        }
}
public void joinCallback(Handle owner, Handle hndl, const char[] error, any clientSerial)
{
	if(hndl == INVALID_HANDLE)
	{
		ThrowError("SQL error: %s", error);
		return;
	}
	int client = GetClientFromSerial(clientSerial);
	char ip[20];
	char country[50];
	if(IsValidClient(client) && IsFakeClient(client))
	{
		country = "Console";
	}
	else if(IsValidClient(client) && !IsFakeClient(client))
	{
		GetClientIP(client, ip, sizeof(ip));
		GeoipCountry(ip, country, sizeof country);
		if(!GeoipCountry(ip, country, sizeof country))
	    {
			country = "Unknown Country";
	    } 
	}
	if(SQL_GetRowCount(hndl) == 0)
	{
		totalmembers++;
		char queryBuffer[255], clientid[32], clientname[MAX_NAME_LENGTH];
		GetClientName(client, clientname, sizeof(clientname));
		GetClientAuthId(client, AuthId_Engine, clientid, sizeof(clientid));
		Format(queryBuffer, sizeof(queryBuffer), "INSERT INTO slayer_whois VALUES ('%s', '%s', %i, '%s')", clientid, clientname, totalmembers, clientname);
		SQL_TQuery(db, Callback, queryBuffer, client);
		if(sJoinMessage.BoolValue)
		{
			CPrintToChatAll("%t %t", "C_Tag", "C_ConnectMsg", clientname, country, clientname, totalmembers, totalmembers);
			if(sShow.BoolValue)PrintToServer("%t %t", "S_Tag", "S_ConnectMsg", clientname, country, clientname, totalmembers, totalmembers);
		}
	}
	else
	{
		char clientname[MAX_NAME_LENGTH];
		GetClientName(client, clientname, sizeof(clientname));
		char oldname[MAX_NAME_LENGTH]; 
		int clientmember;
		if(SQL_FetchRow(hndl))
		{
			SQL_FetchString(hndl, 1, oldname, sizeof(oldname));
			clientmember = SQL_FetchInt(hndl, 2);
		}
		if(sJoinMessage.BoolValue)
		{
			CPrintToChatAll("%t %t", "C_Tag", "C_ConnectMsg", clientname, country, oldname, clientmember, totalmembers);
			if(sShow.BoolValue)PrintToServer("%t %t", "S_Tag", "S_ConnectMsg", clientname, country, oldname, clientmember, totalmembers);
		}
	}	
}
public void OnClientDisconnect(int client)
{
	if(sPluginEnabled.BoolValue && sDisconnectMessage.BoolValue && !IsClientSourceTV(client))
	{
		char queryBuffer[255], clientid[40];
		GetClientAuthId(client, AuthId_Engine, clientid, sizeof(clientid));
		Format(queryBuffer, sizeof(queryBuffer), "SELECT *FROM slayer_whois WHERE steam_id='%s'", clientid);
		SQL_TQuery(db, DisconnectCallback, queryBuffer, GetClientSerial(client));
	}
}
public void DisconnectCallback(Handle owner, Handle hndl, const char[] error, any clientSerial)
{
	if(hndl == INVALID_HANDLE)
	{
		ThrowError("SQL error: %s", error);
		return;
	}
	char clientname[MAX_NAME_LENGTH];char oldname[MAX_NAME_LENGTH]; int clientmember;
	if(SQL_FetchRow(hndl))
	{
		SQL_FetchString(hndl, 3, clientname, sizeof(clientname));
		SQL_FetchString(hndl, 1, oldname, sizeof(oldname));
		clientmember = SQL_FetchInt(hndl, 2);
	}
	CPrintToChatAll("%t %t", "C_Tag", "C_DisconnectMsg", clientname, oldname, clientmember, totalmembers);
	if(sShow.BoolValue)PrintToServer("%t %t", "S_Tag", "S_DisconnectMsg", clientname, oldname, clientmember, totalmembers);
}
public Action cmd_whoisplayers(int client, int args)
{
	if(sPluginEnabled.BoolValue) // Check Plugin is Enabled
	{
		if (client !=0 && args < 1) // If Client is not Console and Given 0 Argument then Open Whois Menu
		{
		    DisplayClientMenu(client);
		    return Plugin_Handled;
		}
		else if(client == 0 && args < 1) // If Client is Console and Given 0 Argument then give Error
		{
			 ReplyToCommand(client, "%t Invaild Syntax. Please type sm_whois <player_name>", "S_Tag");
			 return Plugin_Handled;
		} 
		
		int target;
		char argstring[128];
		GetCmdArgString(argstring, sizeof(argstring));
		target = FindTarget(client, argstring, false, false);
		
		if (target == -1 || IsClientSourceTV(target)) // Target shouldn't be SouceTV and Target should be Vaild
		{
			if(client == 0)ReplyToCommand(client, "%t %t", "S_Tag", "S_InvalidName");
			else ReplyToCommand(client, "%t %t", "C_Tag", "C_InvalidName");
			DisplayClientMenu(client); // Open Menu Cause Target is Invaild so Player can choose target from Menu
			return Plugin_Handled;
		}
		else // if Target is Vaild
		{
			if(client == 0)console = true; // True Boolean if Client is Console
			else console = false; // Otherwise False
			SendSQLQuery(client, target);
		}
	}
	return Plugin_Handled;
}
public void DataCallback1(Handle owner, Handle hndl, const char[] error, any data)
{
	if(hndl == INVALID_HANDLE)
	{
		ThrowError("SQL error: %s", error);
		return;
	}
	
	int client;
	DataPack packData = view_as<DataPack>(data);
	packData.Reset();
	
	if(console == false)
	{
		int clientSerial = ReadPackCell(packData);
		client = GetClientFromSerial(clientSerial);
	}
	
	int targetClientSerial = ReadPackCell(packData);
 	int targetClient = GetClientFromSerial(targetClientSerial);
	delete packData;
	
	bool Admin;
	char ip[20], vip[10], city[46], region[46], country[46], ccode[3], ccode3[4], admincheck[10], clientid[40], clientname[MAX_NAME_LENGTH];
	
	GetClientName(targetClient, clientname, sizeof(clientname));
	GetClientAuthId(targetClient, AuthId_Engine, clientid, sizeof(clientid));
	GetClientIP(targetClient, ip, sizeof(ip));
	GeoipCountry(ip, country, sizeof country)
	char oldname[MAX_NAME_LENGTH]; int clientmember;
	if(SQL_FetchRow(hndl))
	{
		SQL_FetchString(hndl, 1, oldname, sizeof(oldname));
		clientmember = SQL_FetchInt(hndl, 2);
	}
	bool sGeoCityPluginExists = LibraryExists("GeoIPCity");
	
	if(sGeoCityPluginExists == false &&!GeoipCountry(ip, country, sizeof country))
    {
		if(!IsFakeClient(targetClient))country = "Unknown Country";
		if(IsFakeClient(targetClient))country = "Console";
    }
	else if(sGeoCityPluginExists == true && !GeoipGetRecord(ip, city, region, country,ccode,ccode3))
	{
		if(!IsFakeClient(targetClient))country = "Unknown Country";
		if(IsFakeClient(targetClient))country = "Console";
		city= "";
		region= "";
		ccode= "";
		ccode3 = "";
	}
	else
	{
		Format(city,sizeof(city),"%s, ",city);
		Format(region,sizeof(region),"%s, ",region);
	} 
	if(console == false)
	{
		if(!sCanCheck.BoolValue)Admin = false;
		else if(sCanCheck.BoolValue)
		{
			if(CheckPlayerFlags(client))
			{
				Admin = true;
			}
			else
			{
				Admin = false;
			}
		}
	}
	
	vip = "No";
	sVIPPluginExists = LibraryExists("vip_core");
	if (sVIPPluginExists == true && VIP_IsClientVIP(targetClient))vip = "Yes";
	if(GetUserAdmin(targetClient) != INVALID_ADMIN_ID)admincheck = "Yes";
	else admincheck = "No";
	// If Client is Not Console then Print Info in Chat
	if(console == false)
	{
		CPrintToChat(client, "%t", "C_Outline");
		CPrintToChat(client, "%t", "C_Name", clientname);
		CPrintToChat(client, "%t", "C_OldName", oldname);
		if(sSteamID.BoolValue)CPrintToChat(client, "%t", "C_SteamID", clientid);
		if(sCanCheck.BoolValue && Admin == true || !sCanCheck.BoolValue)CPrintToChat(client, "%t", "C_IP", ip);
		if(sCountry.BoolValue)CPrintToChat(client, "%t", "C_Address", city,region,country);
		if(sVIPPluginExists == true && sVIP.BoolValue)CPrintToChat(client, "%t", "C_VIP", vip);
		if(sAdmin.BoolValue)CPrintToChat(client, "%t", "C_Admin", admincheck);
		if(sMember.BoolValue)CPrintToChat(client, "%t", "C_Member", clientmember, totalmembers);
		CPrintToChat(client, "%t", "C_Outline");
	}
	if(console == true || sShow.BoolValue) // If client is Console OR any client use 'sm_whois' command then Print info in Server Console 
	{
		PrintToServer("%t", "S_Outline");
		PrintToServer("%t", "S_Name", clientname);
		PrintToServer("%t", "S_OldName", oldname);
		PrintToServer("%t", "S_SteamID", clientid);
		PrintToServer("%t", "S_IP", ip);
		PrintToServer("%t", "S_Address", city,region,country);
		if(sVIPPluginExists == true)PrintToServer("%t", "S_VIP", vip);
		PrintToServer("%t", "S_Admin", admincheck);
		PrintToServer("%t", "S_Member", clientmember, totalmembers);
		PrintToServer("%t", "S_Outline");
	}
}
public void Callback(Handle owner, Handle hndl, const char[] error, any data)
{
	if(!StrEqual("", error))
	{
		PrintToServer("SLAYER_Whois Last Connect SQL Error: %s", error);
	}
}
stock void DisplayClientMenu(int client)
{
	Menu menu = new Menu(MenuHandler_WhoisMenu);
	SetMenuTitle(menu, "Choose a player to check his Information");
	SetMenuExitBackButton(menu, true);
	AddPlayersToMenu(menu, sAllowBots.BoolValue);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

stock void AddPlayersToMenu(Menu menu, bool AddBots=true)
{
	char name[100], clientid[40];
	int client;
	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsValidClient(i) && !IsFakeClient(i) && !IsClientSourceTV(i))
		{
			GetClientName(i, name, sizeof(name));
			client = GetClientUserId(i);
			IntToString(client, clientid, sizeof(clientid));
			menu.AddItem(clientid, name);
		}
	}
	if(AddBots)
	{
		for(int i = 1; i <= MaxClients; i++)
		{
			if(IsValidClient(i) && IsFakeClient(i) && !IsClientSourceTV(i))
			{
				GetClientName(i, name, sizeof(name));
				client = GetClientUserId(i);
				IntToString(client, clientid, sizeof(clientid));
				menu.AddItem(clientid, name);
			}
		}
	}
}

public MenuHandler_WhoisMenu(Handle menu, MenuAction action, param1, param2)
{
	switch (action)
	{
		case MenuAction_End:
		{
			CloseHandle(menu);
		}
		case MenuAction_Select:
		{
			char info[32];
			int target;
			
			GetMenuItem(menu, param2, info, sizeof(info));
			int userid = StringToInt(info);

			if ((target = GetClientOfUserId(userid)) == 0)
			{
				CPrintToChat(param1, "%t %t", "C_Tag", "C_PlayerNotAvailable");
			}
			else
			{
				SendSQLQuery(param1, target);
			}
		}
	}
}

stock void SendSQLQuery(int client, int target)
{
	char clientid[40];
	char queryBuffer[255];
	GetClientAuthId(target, AuthId_Engine, clientid, sizeof(clientid));
	Format(queryBuffer, sizeof(queryBuffer), "SELECT *FROM slayer_whois WHERE steam_id='%s'", clientid);
	DataPack dataPack = new DataPack();
	if(client != 0)WritePackCell(dataPack, GetClientSerial(client));
	WritePackCell(dataPack, GetClientSerial(target));
	SQL_TQuery(db, DataCallback1, queryBuffer, dataPack);
}

stock bool IsValidClient(int client)
{
	if(client <= 0 ) return false;
	if(client > MaxClients) return false;
	if(!IsClientConnected(client)) return false;
	return IsClientInGame(client);
}